// Test basic pattern matching
// $Id: t2.g,v 1.3 2002/01/31 13:24:11 malekith Exp $

extern_c void print_string(string);
extern_c void print_int(int);

void f(int x)
{
	switch (x) {
	case 1:
		print_string("one ");
	case 2:
		print_string("two ");
	case y:
		print_string("HGW ");
	}
}

void pp(*[int, int] x)
{
	switch (x) {
	case [1, 1]:
		print_string("[one,one] ");
		
	case [1, v]:
		print_string("[one,");
		print_int(v);
		print_string("] ");
		
	case [u, v]:
		print_string("[");
		print_int(u);
		print_string(",");
		print_int(v);
		print_string("] ");
	}
}

int main() export_as "main"
{
        if (1 == 1)
		print_string("ok ");
	f(1);
	f(2);
	f(3);
	pp([1,1]);
	pp([1,2]);
	pp([2,3]);
	print_string(".\n");
	return 0;
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: ok one two HGW [one,one] [one,2] [2,3] .
 */
